

   MEMBER('other.clw')                                     ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('OTHER001.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the WAGES File
!!! </summary>
BrowseWAGES PROCEDURE 

CurrentTab           STRING(80)                            ! 
FilesOpened          BYTE                                  ! 
BRW1::View:Browse    VIEW(WAGES)
                       PROJECT(wag:WagesID)
                       PROJECT(wag:Employee)
                       PROJECT(wag:Department)
                       PROJECT(wag:Salary)
                       PROJECT(wag:Other)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
wag:WagesID            LIKE(wag:WagesID)              !List box control field - type derived from field
wag:Employee           LIKE(wag:Employee)             !List box control field - type derived from field
wag:Department         LIKE(wag:Department)           !List box control field - type derived from field
wag:Salary             LIKE(wag:Salary)               !List box control field - type derived from field
wag:Other              LIKE(wag:Other)                !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the WAGES File'),AT(,,358,188),FONT('MS Sans Serif',8),RESIZE,GRAY,IMM,MDI, |
  HLP('BrowseWAGES'),SYSTEM
                       LIST,AT(8,20,342,124),USE(?Browse:1),HVSCROLL,FORMAT('64R(2)|M~Wages ID~C(0)@n-14@80L(2' & |
  ')|M~Employee~L(2)@s30@80L(2)|M~Department~L(2)@s30@52D(20)|M~Salary~C(0)@N12.2@80L(2' & |
  ')|M~Other~L(2)@s21@'),FROM(Queue:Browse:1),IMM,MSG('Browsing Records')
                       BUTTON('&Insert'),AT(207,148,45,14),USE(?Insert:2)
                       BUTTON('&Change'),AT(256,148,45,14),USE(?Change:2),DEFAULT
                       BUTTON('&Delete'),AT(305,148,45,14),USE(?Delete:2)
                       SHEET,AT(4,4,350,162),USE(?CurrentTab)
                         TAB('Order by Wages ID'),USE(?Tab:2)
                         END
                         TAB('Order by Department'),USE(?Tab:3)
                         END
                       END
                       BUTTON('Close'),AT(260,170,45,14),USE(?Close)
                       BUTTON('Help'),AT(309,170,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseWAGES')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:WAGES.Open()                                      ! File WAGES used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:WAGES,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.AddSortOrder(,wag:Key_Department)                   ! Add the sort order for wag:Key_Department for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,wag:Department,1,BRW1)         ! Initialize the browse locator using  using key: wag:Key_Department , wag:Department
  BRW1.AddSortOrder(,wag:PK_Wages)                         ! Add the sort order for wag:PK_Wages for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(,wag:WagesID,1,BRW1)            ! Initialize the browse locator using  using key: wag:PK_Wages , wag:WagesID
  BRW1.AddField(wag:WagesID,BRW1.Q.wag:WagesID)            ! Field wag:WagesID is a hot field or requires assignment from browse
  BRW1.AddField(wag:Employee,BRW1.Q.wag:Employee)          ! Field wag:Employee is a hot field or requires assignment from browse
  BRW1.AddField(wag:Department,BRW1.Q.wag:Department)      ! Field wag:Department is a hot field or requires assignment from browse
  BRW1.AddField(wag:Salary,BRW1.Q.wag:Salary)              ! Field wag:Salary is a hot field or requires assignment from browse
  BRW1.AddField(wag:Other,BRW1.Q.wag:Other)                ! Field wag:Other is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseWAGES',QuickWindow)                  ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1                                    ! Will call: UpdateWAGES
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:WAGES.Close()
  END
  IF SELF.Opened
    INIMgr.Update('BrowseWAGES',QuickWindow)               ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateWAGES
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

