  MEMBER('root.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
root_BC0:DctInit    PROCEDURE()
root_BC0:DctKill    PROCEDURE()
root_BC0:FilesInit  PROCEDURE()
  END

Hide:Access:WAGES    CLASS(FileManager),TYPE               ! FileManager for WAGES
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:WAGES    CLASS(RelationManager),TYPE           ! RelationManager for WAGES
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:WAGES   &Hide:Access:WAGES,AUTO,THREAD
_Hide:Relate:WAGES   &Hide:Relate:WAGES,AUTO,THREAD


root_BC0:DctInit PROCEDURE()
  CODE
  _Hide:Access:WAGES &= NEW(Hide:Access:WAGES)
  _Hide:Relate:WAGES &= NEW(Hide:Relate:WAGES)
  Relate:WAGES &= _Hide:Relate:WAGES


root_BC0:FilesInit PROCEDURE()
  CODE
  _Hide:Relate:WAGES.Init


root_BC0:DctKill PROCEDURE()
  CODE
  _Hide:Relate:WAGES.Kill
  DISPOSE(_Hide:Relate:WAGES)


Hide:Relate:WAGES.Init PROCEDURE()
  CODE
  _Hide:Access:WAGES.Init
  SELF.Init(Access:WAGES,1)


Hide:Access:WAGES.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= wag:Record
  SELF.FileNameValue = 'WAGES'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= WAGES
  PARENT.Init
  Access:WAGES &= SELF


Hide:Access:WAGES.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:WAGES &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:WAGES.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(WAGES,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(wag:PK_Wages,'wag:PK_Wages',0)
    SELF.AddKey(wag:Key_Department,'wag:Key_Department',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:WAGES.Kill PROCEDURE

  CODE
  _Hide:Access:WAGES.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:WAGES &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:WAGES)                              ! destroy the file manager

